import { useState, useEffect } from "react";
import logo from './logo.svg';
import './App.css';

import {Typography, TextField, InputAdornment, Grid} from "@material-ui/core";


const App = (props) => {
    const [values, setValues] = useState({
        total: 1914,
        skeinLength: "",
        skeinPrice: "",
    });

    const [totalPrice, setTotalPrice] = useState();

    const _handleChange = (event) => {
        const { id, value } = event.target;

        console.log("changing", id, value);

        setValues({
            ...values,
            [id]: Number(value),
        });

        console.log(values);
    };

    useEffect(() => {
        const newTotal = Math.ceil((Number(values.total) / Number(values.skeinLength || 0)))
            * Number(values.skeinPrice);

        setTotalPrice(newTotal);

        console.log("change");
    }, [values]);


    return (
        <div className="App" style={{ width: "400px", margin: "0 auto", }}>
            <Grid container direction="column" spacing={2}>
                <Grid item xs={12}>
                    <Typography variant="h1" gutterBottom>hey, we love yarn!</Typography>
                    <Typography variant="h6">Project details</Typography>
                    <TextField
                        label="Total yardage"
                        id="total"
                        value={values.total}
                        onChange={_handleChange}
                        type="number"
                        fullWidth
                    />
                </Grid>
                <Grid item xs={12}>
                    <Typography variant="h6">Yarn details</Typography>
                    <TextField
                        label="Yardage per skein"
                        id="skeinLength"
                        value={values.skeinLength}
                        onChange={_handleChange}
                        type="number"
                        fullWidth
                    />
                </Grid>
                <Grid item xs={12}>
                    <TextField
                        label="Price per skein"
                        id="skeinPrice"
                        value={values.skeinPrice}
                        onChange={_handleChange}
                        type="number"
                        fullWidth
                        InputProps={{
                            startAdornment: <InputAdornment position="start">$</InputAdornment>,
                        }}
                    />
                </Grid>
                <Grid item xs={12}>
                    <Typography variant="h6">Total project cost</Typography>
                    <TextField
                        id="totalPrice"
                        value={totalPrice}
                        onChange={_handleChange}
                        type="number"
                        fullWidth
                        InputProps={{
                            readOnly: true,
                        }}
                    />
                </Grid>
                <Grid item xs={12}>
                    <Typography component="small">(ps love you)</Typography>
                </Grid>

            </Grid>
        </div>
    );
};

export default App;
